diff -bruN freeswan-1.9.orig/pluto/connections.h freeswan-1.9/pluto/connections.h
--- freeswan-1.9.orig/pluto/connections.h	Sun Jan 28 16:03:02 2001
+++ freeswan-1.9/pluto/connections.h	Wed Jun  6 16:13:22 2001
@@ -11,9 +11,13 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: connections.h,v 1.43 2001/01/28 21:03:02 dhr Exp $
+ * RCSID $Id: connections.h,v 1.54 2001/05/28 19:18:17 dhr Exp $
  */
 
+#ifdef OPENSSL
+#include "openssl_defs.h"
+#endif
+
 /* There are two kinds of connections:
  * - ISAKMP connections, between hosts (for IKE communication)
  * - IPsec connections, between clients (for secure IP communication)
@@ -54,13 +58,16 @@
  *   gateway can get traffic for a specific (client) subnet.
  *   Furthermore, if the routing isn't in place, packets will
  *   be sent in the clear.
- *   "routed" indicates whether the routing has been done for
- *   this connection.
+ *   "routing" indicates whether the routing has been done for
+ *   this connection.  Note that several connections may claim
+ *   the same routing, as long as they agree about where the
+ *   packets are to be sent.
  * - With the current KLIPS, only one outbound IPsec SA bundle can be
  *   used for a particular client.  This is due to a limitation
  *   of using only routing for selection.  So only one IPsec state (SA)
  *   may "own" the eroute.  "eroute_owner" is the serial number of
- *   this state, or SOS_NOBODY if there is none.
+ *   this state, SOS_NOBODY if there is none.  "routing" indicates
+ *   what kind of erouting has been done for this connection, if any.
  *
  * Operations on Connections:
  *
@@ -70,14 +77,27 @@
  * - find a connection (by IP addresses of hosts)
  *   [response to peer request; finding ISAKMP connection for IPsec connection]
  *
- * When a connection is referenced by a state object, it must have
- * the IP addresses of the hosts filled in.  Some connections are
- * missing one or the other IP addresses (essentially "wildcarded",
- * denoted by a value of 0.0.0.0).  When one must be filled in (to allow
- * it to be used by a state object), a new connection is derived from
- * the old one.  It is deleted when no longer in use.
+ * Some connections are templates, missing the address of the peer
+ * (represented by INADDR_ANY).  These are always arranged so that the
+ * missing end is "that" (there can only be one missing end).  These can
+ * be instantiated (turned into real connections) by Pluto in one of two
+ * different ways: Road Warrior Instantiation or Opportunistic
+ * Instantiation.  A template connection is marked for Opportunistic
+ * Instantiation by specifying the peer client as 0.0.0.0/32 (or the IPV6
+ * equivalent).  Otherwise, it is suitable for Road Warrior Instantiation.
+ *
+ * Instantiation creates a new temporary connection, with the missing
+ * details filled in.  The resulting template lasts only as long as there
+ * is a stat that uses it.
  */
 
+#ifdef OPENSSL
+struct other_st {
+  u_int32_t type; /* type of certificate in 'cert': EVP_PKEY_RSA or EVP_PKEY_DSA */
+  void *cert;
+};
+#endif
+
 struct end {
     struct id id;
     ip_address
@@ -92,6 +112,20 @@
 
 struct connection {
     char *name;
+#ifdef OPENSSL
+    /* The declaration of these as void is truly horrific - they 
+     * should be X509 and EVP_PKEY pointers. Unfortunately, if this
+     * is declared, the MD5 header files from OpenSSL conflict with those
+     * in the KLIPS source. Hence we cast these pointers to the right
+     * type at the time of use. It's disgusting, but I can't think of
+     * another way -- ND 
+     */
+    void *cert, *key, *lu;
+    struct other_st other[MAX_OTHER];
+    u_char path[PATH_NAME_LIMIT];
+    u_int32_t cert_options;
+#endif
+    lset_t block_cypher;
     lset_t policy;
     time_t sa_ike_life_seconds;
     time_t sa_ipsec_life_seconds;
@@ -104,20 +138,15 @@
 
     /* internal fields: */
 
+    enum connection_kind kind;
     const struct iface *interface;	/* filled in iff oriented */
-    bool routed;	/* is routing in place for peer's client? */
+    enum routing_t routing;    /* level of routing in place */
+
     so_serial_t	/* state object serial number */
 	newest_isakmp_sa,
 	newest_ipsec_sa,
 	eroute_owner;
 
-    enum rwcs {
-	rwcs_permanent,	/* normal connection */
-	rwcs_instance,	/* instance created for a particular attempt */
-	rwcs_going_away	/* being deleted -- don't delete again */
-    };
-    enum rwcs rw_state;
-
 #ifdef DEBUG
     unsigned int extra_debugging;
 #endif
@@ -129,13 +158,13 @@
     struct gw_info *gw_info;
 
     struct host_pair *host_pair;
-    struct connection *hp_next;
+    struct connection *hp_next;		/* host pair list link */
 
-    struct connection *next;
+    struct connection *ac_next;		/* all connections list link */
 };
 
 #define oriented(c) ((c).interface != NULL)
-extern bool orient(struct connection *c, bool must);
+extern bool orient(struct connection *c);
 
 extern bool same_peer_ids(const struct connection *c
     , const struct connection *d, const struct id *his_id);
@@ -147,27 +176,33 @@
 extern void add_connection(const struct whack_message *wm);
 extern void initiate_connection(const char *name, int whackfd);
 extern void initiate_opportunistic(const ip_address *our_client
-    , const ip_address *peer_client, int whackfd);
+    , const ip_address *peer_client, bool held, int whackfd);
 extern void terminate_connection(const char *nm);
-extern void unorient_connection(struct connection *c);
+extern void release_connection(struct connection *c);
 extern void delete_connection(struct connection *c);
 extern void delete_every_connection(void);
-extern void release_interface(struct iface *i);
-extern struct connection *route_owner(struct connection *c, bool eroute);
+extern void release_dead_interfaces(void);
+extern void check_orientations(void);
+extern struct connection *route_owner(struct connection *c
+    , struct connection **erop);
+extern struct connection *shunt_owner(const ip_subnet *ours
+    , const ip_subnet *his);
+
 
 extern bool uniqueIDs;	/* --uniqueids? */
 extern void ISAKMP_SA_established(struct connection *c, so_serial_t serial);
 
-/* for Road Warrior (and Opportunism) */
-#define HasWildcardIP(c) (isanyaddr(&(c).that.host_addr))
-
-bool HasWildcardClient(const struct connection *c);
+#define his_id_was_instantiated(c) ((c)->kind == CK_INSTANCE \
+    && id_is_ipaddr(&(c)->that.id) \
+    && sameaddr(&(c)->that.id.ip_addr, &(c)->that.host_addr))
+
+/* for Opportunism */
+extern bool HasWildcardClient(const struct connection *c);
+extern const ip_subnet *EffectivePeerClient(const struct connection *c);
 
 struct state;	/* forward declaration of tag (defined in state.h) */
 extern struct connection
     *con_by_name(const char *nm, bool strict),
-    *find_opportunistic_connection(const ip_address *our_client
-	, const ip_address *peer_client),
     *find_host_connection(const ip_address *me, u_int16_t my_port
 	, const ip_address *him, u_int16_t his_port),
     *refine_host_connection(const struct state *st, const struct id *id
@@ -191,5 +226,27 @@
 	, const ip_address *our_client, const ip_address *peer_client),
     *build_outgoing_opportunistic_connection(struct gw_info *gw
 	, const ip_address *our_client, const ip_address *peer_client);
+
+
+/* operations on "pending", the structure representing Quick Mode
+ * negotiations delayed until a Keying Channel has been negotiated.
+ */
+
+struct pending;        /* forward declaration (opaque outside connections.c) */
+extern void add_pending(int whack_sock
+    , struct state *isakmp_sa
+    , struct connection *c
+    , lset_t policy
+    , unsigned long try);
+
+extern void release_pending_whacks(struct state *st, err_t story);
+extern void unpend(struct state *st);
+extern void update_pending(struct state *os, struct state *ns);
+extern void flush_pending_by_state(struct state *st);
+
+extern void connection_discard(struct connection *c);
+
+/* print connection status */
+
 
 extern void show_connections_status(void);
diff -bruN freeswan-1.9.orig/pluto/constants.c freeswan-1.9/pluto/constants.c
--- freeswan-1.9.orig/pluto/constants.c	Sun Jan 28 16:03:02 2001
+++ freeswan-1.9/pluto/constants.c	Wed Jun  6 16:38:34 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: constants.c,v 1.40 2001/01/28 21:03:02 dhr Exp $
+ * RCSID $Id: constants.c,v 1.47 2001/05/29 18:39:56 dhr Exp $
  */
 
 /*
@@ -27,6 +27,7 @@
 #include <freeswan.h>
 
 #include "constants.h"
+#include "defs.h"
 #include "packet.h"
 
 struct enum_names {
@@ -52,6 +53,7 @@
 static const char *const timer_event_name[] = {
 	"EVENT_NULL",
 	"EVENT_REINIT_SECRET",
+	"EVENT_SHUNT_SCAN",
 	"EVENT_SO_DISCARD",
 	"EVENT_RETRANSMIT",
 	"EVENT_SA_REPLACE",
@@ -134,6 +136,33 @@
 	"got encrypted Informational Message",	/* STATE_INFO_PROTECTED */
     };
 
+/* kind of struct connection */
+
+static const char *const connection_kind_name[] = {
+    "CK_TEMPLATE",     /* abstract connection, with wildcard */
+    "CK_PERMANENT",    /* normal connection */
+    "CK_INSTANCE",     /* instance of template, created for a particular attempt */
+    "CK_GOING_AWAY"    /* instance being deleted -- don't delete again */
+};
+
+
+enum_names connection_kind_names =
+    { CK_TEMPLATE, CK_GOING_AWAY, connection_kind_name, NULL };
+
+/* routing status names */
+
+static const char *const routing_story_strings[] = {
+    "unrouted",        /* RT_UNROUTED: unrouted */
+    "unrouted HOLD",   /* RT_UNROUTED_HOLD: unrouted, but HOLD eroute installed */
+    "trap erouted",    /* RT_ROUTED_PROSPECTIVE: routed, and TRAP eroute installed */
+    "routed HOLD",     /* RT_ROUTED_HOLD: routed, and HOLD eroute installed */
+    "fail erouted",    /* RT_ROUTED_FAILURE: routed, and failure-context shunt eroute installed */
+    "erouted", /* RT_ROUTED_TUNNEL: routed, and erouted to an IPSEC SA group */
+    };
+
+enum_names routing_story =
+    { RT_UNROUTED, RT_ROUTED_TUNNEL, routing_story_strings, NULL};
+
 /* Payload types (draft-ietf-ipsec-isakmp-09.txt section 3.1) */
 
 const char *const payload_name[] = {
@@ -283,18 +312,45 @@
 enum_names ident_names =
     { ID_IPV4_ADDR, ID_KEY_ID, ident_name, NULL };
 
+#ifdef OPENSSL
+/* Certificate type values */
+static const char *const cert_name[] = {
+       "CERT_TYPE_NONE",
+       "CERT_TYPE_PKCS7",
+       "CERT_TYPE_PGP",
+       "CERT_TYPE_DNSKEY",
+       "CERT_TYPE_X509_SIG",
+       "CERT_TYPE_X509_KEX",
+       "CERT_TYPE_KERBEROS",
+       "CERT_TYPE_CRL",
+       "CERT_TYPE_ARL",
+       "CERT_TYPE_SPKI",
+       "CERT_TYPE_X509_ATTR",
+    };
+
+enum_names cert_names =
+    { CERT_TYPE_NONE, CERT_TYPE_X509_ATTR, cert_name, NULL };
+#endif
+
+
 /* Goal BITs for establishing an SA
  * Note: we drop the POLICY_ prefix so that logs are more concise.
  */
 
 const char *const sa_policy_bit_names[] = {
 	"PSK",
+#ifndef OPENSSL
 	"RSASIG",
+#else
+	"OPENSSL",
+#endif
 	"ENCRYPT",
 	"AUTHENTICATE",
 	"COMPRESS",
 	"TUNNEL",
 	"PFS",
+	"PASS",
+	"DROP",
 	NULL
     };
 
@@ -607,6 +663,10 @@
 
 enum_names af_names = { AF_INET, AF_INET, af_inet_name, &af_names6 };
 
+static ip_address ipv4_any, ipv6_any;
+static ip_subnet ipv4_wildcard, ipv6_wildcard;
+static ip_subnet ipv4_all, ipv6_all;
+
 struct af_info af_inet4_info = {
 	AF_INET,
 	"AF_INET",
@@ -614,6 +674,7 @@
 	sizeof(struct sockaddr_in),
 	32,
 	ID_IPV4_ADDR, ID_IPV4_ADDR_SUBNET, ID_IPV4_ADDR_RANGE,
+	&ipv4_any, &ipv4_wildcard, &ipv4_all,
     };
 
 struct af_info af_inet6_info = {
@@ -623,6 +684,7 @@
 	sizeof(struct sockaddr_in6),
 	128,
 	ID_IPV6_ADDR, ID_IPV6_ADDR_SUBNET, ID_IPV6_ADDR_RANGE,
+	&ipv6_any, &ipv6_wildcard, &ipv6_all,
     };
 
 const struct af_info *
@@ -732,6 +794,26 @@
 	p = buf;
     }
     return p;
+}
+
+void init_constants(void)
+{
+    err_t ugh;
+
+    ugh = anyaddr(AF_INET, &ipv4_any);
+    passert(ugh == NULL);
+    ugh = anyaddr(AF_INET, &ipv6_any);
+    passert(ugh == NULL);
+
+    ugh = rangetosubnet(&ipv4_any, &ipv4_any, &ipv4_wildcard);
+    passert(ugh == NULL);
+    ugh = rangetosubnet(&ipv6_any, &ipv6_any, &ipv6_wildcard);
+    passert(ugh == NULL);
+
+    ugh = initsubnet(&ipv4_any, 0, '0', &ipv4_all);
+    passert(ugh == NULL);
+    ugh = initsubnet(&ipv6_any, 0, '0', &ipv6_all);
+    passert(ugh == NULL);
 }
 
 /* construct a string to name the bits on in a set
diff -bruN freeswan-1.9.orig/pluto/constants.h freeswan-1.9/pluto/constants.h
--- freeswan-1.9.orig/pluto/constants.h	Sun Jan 28 16:03:03 2001
+++ freeswan-1.9/pluto/constants.h	Wed Jun  6 16:34:55 2001
@@ -12,9 +12,11 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: constants.h,v 1.58 2001/01/28 21:03:03 dhr Exp $
+ * RCSID $Id: constants.h,v 1.68 2001/05/29 18:39:56 dhr Exp $
  */
 
+extern void init_constants(void);
+
 /*
  * NOTE:For debugging purposes, constants.c has tables to map numbers back to names.
  * Any changes here should be reflected there.
@@ -47,7 +49,8 @@
 typedef unsigned long lset_t;
 #define LEMPTY 0UL
 #define LELEM(opt) (1UL << (opt))
-#define LRANGE(lwb, upb) (LELEM(upb) + LELEM(upb) - LELEM(lwb))
+#define LRANGE(lwb, upb) LRANGES(LELEM(lwb), LELEM(upb))
+#define LRANGES(first, last) (last - first + last)
 #define LALLIN(set, probe)	(((set) & (probe)) == (probe))
 
 /* Control and lock pathnames */
@@ -158,12 +161,15 @@
 
 extern enum_names timer_event_names;
 
-#define EVENT_NULL				0 /* non-event */
-#define EVENT_REINIT_SECRET			1 /* Refresh cookie secret */
-#define EVENT_SO_DISCARD			2 /* discard unfinished state object */
-#define EVENT_RETRANSMIT			3 /* Retransmit packet */
-#define EVENT_SA_REPLACE			4 /* SA replacement event */
-#define EVENT_SA_EXPIRE				5 /* SA expiration event */
+enum event_type {
+    EVENT_NULL,        /* non-event */
+    EVENT_REINIT_SECRET,       /* Refresh cookie secret */
+    EVENT_SHUNT_SCAN,  /* scan shunt eroutes known to kernel */
+    EVENT_SO_DISCARD,  /* discard unfinished state object */
+    EVENT_RETRANSMIT,  /* Retransmit packet */
+    EVENT_SA_REPLACE,  /* SA replacement event */
+    EVENT_SA_EXPIRE    /* SA expiration event */
+};
 
 #define EVENT_REINIT_SECRET_DELAY		3600 /* 1 hour */
 #define EVENT_RETRANSMIT_DELAY_0		10   /* 10 seconds */
@@ -265,25 +271,37 @@
 extern enum_names state_names;
 extern const char *const state_story[];
 
-#define STATE_MAIN_R0       1
-#define STATE_MAIN_I1       2
-#define STATE_MAIN_R1       3
-#define STATE_MAIN_I2       4
-#define STATE_MAIN_R2       5
-#define STATE_MAIN_I3       6
-#define STATE_MAIN_R3       7
-#define STATE_MAIN_I4       8
-
-#define STATE_QUICK_R0      9
-#define STATE_QUICK_I1      10
-#define STATE_QUICK_R1      11
-#define STATE_QUICK_I2      12
-#define STATE_QUICK_R2      13
+enum state_kind {
+    STATE_UNDEFINED,   /* 0 -- most likely accident */
+
+    /*  Opportunism states: see "Opportunistic Encryption" 2.2 */
+
+    OPPO_ACQUIRE,      /* got an ACQUIRE message for this pair */
+    OPPO_GW_DISCOVERED,        /* got TXT specifying gateway */
 
-#define STATE_INFO           14
-#define STATE_INFO_PROTECTED 15
+    /* IKE states */
+
+    STATE_MAIN_R0,
+    STATE_MAIN_I1,
+    STATE_MAIN_R1,
+    STATE_MAIN_I2,
+    STATE_MAIN_R2,
+    STATE_MAIN_I3,
+    STATE_MAIN_R3,
+    STATE_MAIN_I4,
+
+    STATE_QUICK_R0,
+    STATE_QUICK_I1,
+    STATE_QUICK_R1,
+    STATE_QUICK_I2,
+    STATE_QUICK_R2,
 
-#define STATE_ROOF          16
+    STATE_INFO,
+    STATE_INFO_PROTECTED
+};
+
+#define STATE_IKE_FLOOR        STATE_MAIN_R0
+#define STATE_IKE_ROOF (STATE_INFO_PROTECTED + 1)
 
 #define IS_PHASE1(s) (STATE_MAIN_R0 <= (s) && (s) <= STATE_MAIN_I4)
 #define IS_QUICK(s) (STATE_QUICK_R0 <= (s) && (s) <= STATE_QUICK_R2)
@@ -291,6 +309,37 @@
 #define IS_IPSEC_SA_ESTABLISHED(s) ((s) == STATE_QUICK_I2 || (s) == STATE_QUICK_R2)
 #define IS_ONLY_INBOUND_IPSEC_SA_ESTABLISHED(s) ((s) == STATE_QUICK_R1)
 
+/* kind of struct connection */
+
+extern enum_names connection_kind_names;
+
+enum connection_kind {
+    CK_TEMPLATE,       /* abstract connection, with wildcard */
+    CK_PERMANENT,      /* normal connection */
+    CK_INSTANCE,       /* instance of template, created for a particular attempt */
+    CK_GOING_AWAY      /* instance being deleted -- don't delete again */
+};
+
+
+/* routing status.
+ * Note: routing ignores source address, but erouting does not!
+ */
+
+extern enum_names routing_story;
+
+enum routing_t {
+    RT_UNROUTED,       /* unrouted */
+    RT_UNROUTED_HOLD,  /* unrouted, but HOLD shunt installed */
+    RT_ROUTED_PROSPECTIVE,     /* routed, and TRAP shunt installed */
+    RT_ROUTED_HOLD,    /* routed, and HOLD shunt installed */
+    RT_ROUTED_FAILURE, /* routed, and failure-context shunt installed */
+    RT_ROUTED_TUNNEL   /* routed, and erouted to an IPSEC SA group */
+};
+
+#define routed(rs) ((rs) > RT_UNROUTED_HOLD)
+#define erouted(rs) ((rs) != RT_UNROUTED)
+#define shunt_erouted(rs) (erouted(rs) && (rs) != RT_ROUTED_TUNNEL)
+
 /* Payload types
  * RFC2408 Internet Security Association and Key Management Protocol (ISAKMP)
  * section 3.1
@@ -460,27 +509,77 @@
 #define ID_DER_ASN1_GN              10
 #define ID_KEY_ID                   11
 
+#ifdef OPENSSL
+#define CERT_OPTION_SEND           0x01
+#define CERT_OPTION_PKCS7          0x02
+#define CERT_OPTION_PK             0x04
+#define CERT_OPTION_REV            0x08
+#define CERT_OPTION_STRICT         0x10
+#define CERT_OPTION_DSS_SHA        0x20
+#define CERT_OPTION_DSS_ALT        0x40
+
+extern enum_names cert_names;
+
+#define CERT_TYPE_NONE              0
+#define CERT_TYPE_PKCS7             1
+#define CERT_TYPE_PGP               2
+#define CERT_TYPE_DNSKEY            3
+#define CERT_TYPE_X509_SIG          4
+#define CERT_TYPE_X509_KEX          5
+#define CERT_TYPE_KERBEROS          6
+#define CERT_TYPE_CRL               7
+#define CERT_TYPE_ARL               8
+#define CERT_TYPE_SPKI              9
+#define CERT_TYPE_X509_ATTR        10
+#endif
+
 /* Policies for establishing an SA
  *
- * These are used to specify attributes (eg. encryption) and techniques for
- * (eg PFS) required of an SA.  POLICY_PSK and POLICY_RSASIG are for
- * ISAKMP SAs; the rest are about IPsec SAs
+ * These are used to specify attributes (eg. encryption) and techniques
+ * (eg PFS) for an SA.
  */
 
 extern const char *const sa_policy_bit_names[];
 
+/* ISAKMP auth techniques */
 #define POLICY_PSK           LELEM(0)
+#ifndef OPENSSL
 #define POLICY_RSASIG        LELEM(1)
+#else
+#define POLICY_OPENSSL        LELEM(1)
+#endif
 
-#define POLICY_ENCRYPT       LELEM(2)
-#define POLICY_AUTHENTICATE  LELEM(3)
+#define POLICY_ISAKMP_SHIFT    0       /* log2(POLICY_PSK) */
+#ifndef OPENSSL
+#define POLICY_ID_AUTH_MASK    LRANGES(POLICY_PSK, POLICY_RSASIG)
+#else
+#define POLICY_ID_AUTH_MASK    LRANGES(POLICY_PSK, POLICY_OPENSSL)
+#endif
+#define POLICY_ISAKMP_MASK     POLICY_ID_AUTH_MASK     /* all so far */
+
+/* Quick Mode (IPSEC) attributes */
+#define POLICY_ENCRYPT       LELEM(2)  /* must be first of IPSEC policies */
+#define POLICY_AUTHENTICATE  LELEM(3)  /* must be second */
 #define POLICY_COMPRESS      LELEM(4)
 #define POLICY_TUNNEL        LELEM(5)
 #define POLICY_PFS           LELEM(6)
 
-#define POLICY_ISAKMP_SHIFT	0	/* log2(POLICY_PSK) */
-#define POLICY_ISAKMP_MASK	(POLICY_PSK | POLICY_RSASIG)
 #define POLICY_IPSEC_SHIFT	2	/* log2(POLICY_ENCRYPT) */
+#define POLICY_IPSEC_MASK      LRANGES(POLICY_ENCRYPT, POLICY_PFS)
+
+/* opportunistic attributes: what to do with a packet without a tunnel */
+#define POLICY_PASS     LELEM(7)
+#define POLICY_DROP     LELEM(8)
+/* PASS | DROP is construed as REJECT */
+
+#define POLICY_OPPO_SHIFT      7       /* log2(POLICY_PASS) */
+#define POLICY_OPPO_MASK       (POLICY_PASS | POLICY_DROP)
+
+
+/* Any IPsec policy?  If not, a connection description
+ * is only for ISAKMP SA, not IPSEC SA.  (A pun, I admit.)
+ */
+#define HAS_IPSEC_POLICY(p) (((p) & POLICY_IPSEC_MASK) != 0)
 
 /* Oakley transform attributes
  * draft-ietf-ipsec-ike-01.txt appendix A
@@ -532,6 +631,15 @@
 /* SA Lifetime Type attribute
  * RFC2407 The Internet IP security Domain of Interpretation for ISAKMP 4.5
  * Default time specified in 4.5
+ *
+ * There are two defaults for IPSEC SA lifetime, SA_LIFE_DURATION_DEFAULT,
+ * and PLUTO_SA_LIFE_DURATION_DEFAULT.
+ * SA_LIFE_DURATION_DEFAULT is specified in RFC2407 "The Internet IP
+ * Security Domain of Interpretation for ISAKMP" 4.5.  It applies when
+ * an ISAKMP negotiation does not explicitly specify a life duration.
+ * PLUTO_SA_LIFE_DURATION_DEFAULT is specified in pluto(8).  It applies
+ * when a connection description does not specify --ipseclifetime.
+ * The value of SA_LIFE_DURATION_MAXIMUM is our local policy.
  */
 
 extern enum_names sa_lifetime_names;
@@ -539,8 +647,9 @@
 #define SA_LIFE_TYPE_SECONDS   1
 #define SA_LIFE_TYPE_KBYTES    2
 
-#define SA_LIFE_DURATION_DEFAULT    28800 /* Eight hours */
-#define SA_LIFE_DURATION_MAXIMUM    86400 /* One day */
+#define SA_LIFE_DURATION_DEFAULT    28800 /* eight hours (RFC2407 4.5) */
+#define PLUTO_SA_LIFE_DURATION_DEFAULT    28800 /* eight hours (pluto(8)) */
+#define SA_LIFE_DURATION_MAXIMUM    86400 /* one day */
 
 #define SA_REPLACEMENT_MARGIN_DEFAULT	    540	  /* (IPSEC & IKE) nine minutes */
 #define SA_REPLACEMENT_FUZZ_DEFAULT	    100	  /* (IPSEC & IKE) 100% of MARGIN */
@@ -548,6 +657,12 @@
 
 #define SA_LIFE_DURATION_K_DEFAULT  0xFFFFFFFFlu
 
+/* DES support */
+#define ALL_BLOCK_CYPHER 1
+#define DES_BLOCK_CYPHER 2
+#define DES3_BLOCK_CYPHER 3
+#define FORCE_ENCRYPT_CYPHER_DEFAULT ALL_BLOCK_CYPHER
+
 /* Encapsulation Mode attribute */
 
 extern enum_names enc_mode_names;
@@ -568,14 +683,18 @@
 
 /* Oakley Lifetime Type attribute
  * draft-ietf-ipsec-ike-01.txt appendix A
+ * As far as I can see, there is not specification for
+ * OAKLEY_ISAKMP_SA_LIFETIME_DEFAULT.  This could lead to interop problems!
+ * For no particular reason, we chose one hour.
+ * The value of OAKLEY_ISAKMP_SA_LIFETIME_MAXIMUM is our local policy.
  */
 extern enum_names oakley_lifetime_names;
 
 #define OAKLEY_LIFE_SECONDS   1
 #define OAKLEY_LIFE_KILOBYTES 2
 
-#define OAKLEY_ISAKMP_SA_LIFETIME_DEFAULT 3600    /* One hour */
-#define OAKLEY_ISAKMP_SA_LIFETIME_MAXIMUM 28800   /* 8 hours */
+#define OAKLEY_ISAKMP_SA_LIFETIME_DEFAULT 3600    /* one hour */
+#define OAKLEY_ISAKMP_SA_LIFETIME_MAXIMUM 28800   /* eight hours */
 
 /* Oakley PRF attribute (none defined)
  * draft-ietf-ipsec-ike-01.txt appendix A
@@ -744,6 +863,9 @@
     size_t sa_sz;
     int mask_cnt;
     u_int8_t id_addr, id_subnet, id_range;
+    const ip_address *any;
+    const ip_subnet *wildcard; /* 0.0.0.0/32 or IPv6 equivalent */
+    const ip_subnet *all;      /* 0.0.0.0/0 or IPv6 equivalent */
 };
 
 extern const struct af_info
diff -bruN freeswan-1.9.orig/pluto/cookie.c freeswan-1.9/pluto/cookie.c
--- freeswan-1.9.orig/pluto/cookie.c	Wed Oct 25 20:58:05 2000
+++ freeswan-1.9/pluto/cookie.c	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: cookie.c,v 1.13 2000/10/26 00:58:05 dhr Exp $
+ * RCSID $Id: cookie.c,v 1.14 2001/03/13 09:22:03 dhr Exp $
  */
 
 #include <stdio.h>
@@ -20,6 +20,8 @@
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
+
+#include <freeswan.h>
 
 #include "constants.h"
 #include "defs.h"
diff -bruN freeswan-1.9.orig/pluto/crypto.h freeswan-1.9/pluto/crypto.h
--- freeswan-1.9.orig/pluto/crypto.h	Sun Dec 12 19:40:50 1999
+++ freeswan-1.9/pluto/crypto.h	Wed May 16 10:57:20 2001
@@ -56,7 +56,11 @@
 /* unification of cryptographic hashing mechanisms */
 
 union hash_ctx {
+#ifndef OPENSSL
 	MD5_CTX ctx_md5;
+#else
+	PLUTO_MD5_CTX ctx_md5;
+#endif
 	SHA1_CTX ctx_sha1;
     };
 
diff -bruN freeswan-1.9.orig/pluto/defs.c freeswan-1.9/pluto/defs.c
--- freeswan-1.9.orig/pluto/defs.c	Wed Oct 25 18:05:02 2000
+++ freeswan-1.9/pluto/defs.c	Wed May 16 10:57:20 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: defs.c,v 1.17 2000/10/25 22:05:02 dhr Exp $
+ * RCSID $Id: defs.c,v 1.18 2001/03/13 09:22:03 dhr Exp $
  */
 
 #include <stdlib.h>
@@ -19,9 +19,13 @@
 #include <stdio.h>
 #include <sys/types.h>
 
+#include <freeswan.h>
+
 #include "constants.h"
 #include "defs.h"
 #include "log.h"
+#include "id.h"
+#include "connections.h" /* needs id.h */
 #include "whack.h"	/* for RC_LOG_SERIOUS */
 
 const chunk_t empty_chunk = { NULL, 0 };
diff -bruN freeswan-1.9.orig/pluto/defs.h freeswan-1.9/pluto/defs.h
--- freeswan-1.9.orig/pluto/defs.h	Wed Oct 25 18:05:02 2000
+++ freeswan-1.9/pluto/defs.h	Thu Jun  7 12:09:54 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: defs.h,v 1.24 2000/10/25 22:05:02 dhr Exp $
+ * RCSID $Id: defs.h,v 1.26 2001/05/08 05:37:21 dhr Exp $
  */
 
 /* GCC magic! */
@@ -38,7 +38,7 @@
  */
 typedef unsigned long so_serial_t;
 #define SOS_NOBODY  0	/* null serial number */
-
+#define SOS_FIRST	1	/* first normal serial number */
 
 /* memory allocation */
 
@@ -59,6 +59,19 @@
 #define pfreeany(p) { if ((p) != NULL) pfree(p); }
 #define replace(p, q) { pfreeany(p); (p) = (q); }
 
+#ifdef OPENSSL
+#include <des.h>
+
+typedef union _keysched_u {
+  struct _des3_ks { des_key_schedule ks[3]; } des3_ks;
+  des_key_schedule des_ks;
+
+#ifdef NOTYET
+  /* Other ciphers, eg CAST, RC5, etc... */
+#endif
+
+} keysched;
+#endif
 
 /* chunk is a simple pointer-and-size abstraction */
 
@@ -83,6 +96,9 @@
 extern void exit_pluto(int /*status*/) NEVER_RETURNS;
 
 
+/* zero all bytes */
+#define zero(x) memset((x), '\0', sizeof(*(x)))
+
 /* are all bytes 0? */
 extern bool all_zero(const unsigned char *m, size_t len);
 
@@ -105,3 +121,31 @@
 
 /* pad_up(n, m) is the amount to add to n to make it a multiple of m */
 #define pad_up(n, m) (((m) - 1) - (((n) + (m) - 1) % (m)))
+
+/* writemem_short adds support to write to unaligned memory (arm). */
+#ifdef __arm__
+#define writemem_u_int16_t(addr, offset, n) do {\
+  u_int16_t temp16 = htons((n)); \
+  (addr)[(offset)] = temp16 & 0xff; \
+  (addr)[(offset)+1] = temp16 >> 8; \
+} while (0)
+#else
+#define writemem_u_int16_t(addr, offset, n) do {\
+  *((u_int16_t *)(&((addr)[(offset)]))) = htons((n)); \
+} while (0)
+#endif
+
+/* readmem_short adds support to read from unaligned memory (arm). */
+#ifdef __arm__
+#define readmem_u_int16_t(addr, offset, var) do {\
+  u_int16_t temp16 = 0; \
+  temp16 += *((u_int8_t *)(&((addr)[(offset)]))) << 8; \
+  temp16 += *((u_int8_t *)(&((addr)[(offset)+1]))); \
+  (var) = temp16; \
+} while (0)
+#else
+#define readmem_u_int16_t(addr, offset, var) do {\
+  u_int16_t temp16 = ntohs(*((u_int16_t *)(&((addr)[(offset)])))); \
+  (var) = temp16; \
+} while (0)
+#endif
